Add a new daemon security option: "munge symlinks".
[rsync/rsync.git] / testsuite / rsync.fns
1 #! /bin/sh
2
3 # Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5 # General-purpose test functions for rsync.
6
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License version
9 # 2 as published by the Free Software Foundation.
10 #
11 # This program is distributed in the hope that it will be useful, but
12 # WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
14 # Lesser General Public License for more details.
15
16 # You should have received a copy of the GNU Lesser General Public
17 # License along with this program; if not, write to the Free Software
18 # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
21 tmpdir="$scratchdir"
22 fromdir="$tmpdir/from"
23 todir="$tmpdir/to"
24 chkdir="$tmpdir/chk"
25
26 # Berkley's nice.
27 PATH="$PATH:/usr/ucb"
28
29 if diff -u "$srcdir/testsuite/rsync.fns" "$srcdir/testsuite/rsync.fns" >/dev/null 2>&1; then
30     diffopt="-u"
31 else
32     diffopt="-c"
33 fi
34
35 HOME="$scratchdir"
36 export HOME
37
38 runtest() {
39     echo $ECHO_N "Test $1: $ECHO_C"
40     if eval "$2"
41     then
42         echo "$ECHO_T   done."
43         return 0
44     else
45         echo "$ECHO_T failed!"
46         return 1
47     fi
48 }
49
50 # Call this if you want to filter out verbose messages (-v or -vv) from
51 # the output of an rsync run (whittling the output down to just the file
52 # messages).  This isn't needed if you use -i without -v.
53 filter_outfile() {
54     sed -e '/^building file list /d' \
55         -e '/^sending incremental file list/d' \
56         -e '/^created directory /d' \
57         -e '/^done$/d' \
58         -e '/ --whole-file$/d' \
59         -e '/^total: /d' \
60         -e '/^client charset: /d' \
61         -e '/^server charset: /d' \
62         -e '/^$/,$d' \
63         <"$outfile" >"$outfile.new"
64     mv "$outfile.new" "$outfile"
65 }
66
67 printmsg() {
68     echo "$1"
69 }
70
71 rsync_ls_lR() {
72     find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls" $TLS_ARGS
73 }
74
75 check_perms() {
76     perms=`"$TOOLDIR/tls" "$1" | sed 's/^[-d]\(.........\).*/\1/'`
77     if test $perms = $2; then
78         return 0
79     fi
80     echo "permissions: $perms on $1"
81     echo "should be:   $2"
82     test_fail "failed test $3"
83 }
84
85 rsync_getgroups() { 
86     "$TOOLDIR/getgroups"
87 }
88
89
90 ####################
91 # Build test directories $todir and $fromdir, with $fromdir full of files.
92
93 hands_setup() {
94     # Clean before creation
95     rm -rf "$fromdir"
96     rm -rf "$todir"
97
98     [ -d "$tmpdir" ] || mkdir "$tmpdir"
99     [ -d "$fromdir" ] || mkdir "$fromdir"
100     [ -d "$todir" ] || mkdir "$todir"
101
102     # On some BSD systems, the umask affects the mode of created
103     # symlinks, even though the mode apparently has no effect on how
104     # the links behave in the future, and it cannot be changed using
105     # chmod!  rsync always sets its umask to 000 so that it can
106     # accurately recreate permissions, but this script is probably run
107     # with a different umask. 
108
109     # This causes a little problem that "ls -l" of the two will not be
110     # the same.  So, we need to set our umask before doing any creations.
111
112     # set up test data
113     touch "$fromdir/empty"
114     mkdir "$fromdir/emptydir"
115
116     # a hundred lines of text or so
117     rsync_ls_lR "$srcdir" > "$fromdir/filelist"
118
119     echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
120     umask 0
121     ln -s nolf "$fromdir/nolf-symlink"
122     umask 022
123
124     cat "$srcdir"/*.c > "$fromdir/text"
125     mkdir "$fromdir/dir"
126     cp "$fromdir/text" "$fromdir/dir"
127     mkdir "$fromdir/dir/subdir"
128     echo some data > "$fromdir/dir/subdir/foobar.baz"
129     mkdir "$fromdir/dir/subdir/subsubdir"
130     if [ -r /etc ]; then
131         ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
132     else
133         ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
134     fi
135     mkdir "$fromdir/dir/subdir/subsubdir2"
136     if [ -r /bin ]; then
137         ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
138     else
139         ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
140     fi
141
142 #      echo testing head:
143 #      ls -lR "$srcdir" | head -10 || echo failed
144 }
145
146
147 ####################
148 # Many machines do not have "mkdir -p", so we have to build up long paths.
149 # How boring.  
150 makepath() {
151     for p in "${@}"; do
152         (echo "        makepath $p"
153
154         # Absolut Unix.
155         if echo $p | grep '^/' >/dev/null
156         then
157             cd /
158         fi
159     
160         # This will break if $p contains a space.
161         for c in `echo $p | tr '/' ' '`
162         do 
163             if [ -d "$c" ] || mkdir "$c" 
164             then
165                 cd "$c" || return $?
166             else
167                 echo "failed to create $c" >&2; return $?
168             fi
169         done)
170     done
171 }
172
173
174
175 ###########################
176 # Run a test (in '$1') then compare directories $2 and $3 to see if
177 # there are any difference.  If there are, explain them.
178
179 # So normally basically $1 should be an rsync command, and $2 and $3
180 # the source and destination directories.  This is only good when you
181 # expect to transfer the whole directory exactly as is.  If some files
182 # should be excluded, you might need to use something else.
183
184 checkit() {
185     failed=
186
187     # We can just write everything to stdout/stderr, because the
188     # wrapper hides it unless there is a problem.
189
190     echo "Running: \"$1\""  
191     eval "$1" 
192     status=$?
193     if [ $status != 0 ]; then
194         failed="YES";
195     fi
196
197     echo "-------------"
198     echo "check how the directory listings compare with diff:"
199     echo ""
200     ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
201     ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
202     diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
203
204     echo "-------------"
205     echo "check how the files compare with diff:"
206     echo ""
207     if [ "x$4" != x ]; then
208         echo "  === Skipping (as directed) ==="
209     else
210         diff -r $diffopt "$2" "$3" || failed=YES
211     fi
212
213     echo "-------------"
214     if [ -z "$failed" ] ; then
215         return 0
216     else
217         return 1
218     fi
219 }
220
221
222 build_rsyncd_conf() {
223     # Build an appropriate configuration file
224     conf="$scratchdir/test-rsyncd.conf"
225     echo "building configuration $conf"
226
227     port=2612
228     pidfile="$scratchdir/rsyncd.pid"
229     logfile="$scratchdir/rsyncd.log"
230     hostname=`uname -n`
231
232     cat >"$conf" <<EOF
233 # rsyncd configuration file autogenerated by $0
234
235 pid file = $pidfile
236 use chroot = no
237 munge symlinks = no
238 hosts allow = localhost 127.0.0.0/24 192.168.0.0/16 10.0.0.0/8 $hostname
239 log file = $logfile
240 log format = %i %h [%a] %m (%u) %l %f%L
241 transfer logging = yes
242 exclude = foobar.baz
243 max verbosity = 9
244 uid = 0
245 gid = 0
246
247 [test-from]
248         path = $fromdir
249         read only = yes
250
251 [test-to]
252         path = $todir
253         read only = no
254
255 [test-scratch]
256         path = $scratchdir
257         read only = no
258 EOF
259 }
260
261
262 build_symlinks() {
263     mkdir "$fromdir"
264     date >"$fromdir/referent"
265     ln -s referent "$fromdir/relative"
266     ln -s "$fromdir/referent" "$fromdir/absolute"
267     ln -s nonexistent "$fromdir/dangling"
268     ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
269 }
270
271 test_fail() {
272     echo "$@" >&2
273     exit 1
274 }
275
276 test_skipped() {
277     echo "$@" >&2
278     echo "$@" > "$tmpdir/whyskipped"
279     exit 77
280 }
281
282 # It failed, but we expected that.  don't dump out error logs, 
283 # because most users won't want to see them.  But do leave
284 # the working directory around.
285 test_xfail() {
286     echo "$@" >&2
287     exit 78
288 }
289
290 # Determine what shell command will appropriately test for links.
291 ln -s foo "$scratchdir/testlink"
292 for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
293 do
294     for switch in -h -L
295     do
296         if $cmd $switch "$scratchdir/testlink" 2>/dev/null
297         then
298             # how nice
299             TEST_SYMLINK_CMD="$cmd $switch"
300             # i wonder if break 2 is portable?
301             break 2
302         fi
303    done
304 done
305 # ok, now get rid of it
306 rm "$scratchdir/testlink"
307
308
309 if [ "x$TEST_SYMLINK_CMD" = 'x' ]
310 then
311     test_fail "Couldn't determine how to test for symlinks"
312 else
313     echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
314 fi
315         
316
317 # Test whether something is a link, allowing for shell peculiarities
318 is_a_link() {
319     # note the variable contains the first option and therefore is not quoted
320     $TEST_SYMLINK_CMD "$1"
321 }
322
323
324 # We need to set the umask to be reproducible.  Note also that when we
325 # do some daemon tests as root, we will setuid() and therefore the
326 # directory has to be writable by the nobody user in some cases.  The
327 # best thing is probably to explicitly chmod those directories after
328 # creation.
329  
330 umask 022